import QtQuick 1.1
import com.nokia.meego 1.1

PageStack{
	id:root;
	signal openFbaFile(string file);
	property alias model:lst.model;
	signal filterRomlist(int flag);
	signal refrushRomlist(int flag);
    signal searchRomindex(string head);

	HeadView{
		id:head;
		width:parent.width;
        title:qsTr("Choice FBA Rom File");
	}

    //Rectangle{
        Column{
            id:tools;
            width:parent.width;
            height:160;
            z:1;
            anchors.top:head.bottom;
        ButtonRow{
            id:buttonrow;
            width:parent.width;
            Button{
                id:allbutton
                text:qsTr("All");
                onClicked:{
                    filterRomlist(0);
                    lst.currentIndex = 0;
                    lst.positionViewAtBeginning();
                }
            }
            Button{
                id:availablebutton;
                text:qsTr("Available Only");
                onClicked:{
                    filterRomlist(1);
                    lst.currentIndex = 0;
                    lst.positionViewAtBeginning();
                }
            }
            Button{
                id:missingbutton;
                text:qsTr("Missing Only");
                onClicked:{
                    filterRomlist(2);
                    lst.currentIndex = 0;
                    lst.positionViewAtBeginning();
                }
            }
        }
        Button{
            width:root.width;
            text:qsTr("Refrush");
            onClicked:{
                var cur;
                if(buttonrow.checkedButton === allbutton)
                    cur = 0;
                else if(buttonrow.checkedButton === availablebutton)
                    cur = 1;
                else if(buttonrow.checkedButton === missingbutton)
                    cur = 2;
                //console.log(cur);
                refrushRomlist(cur);
                lst.currentIndex = 0;
                lst.positionViewAtBeginning();
            }
        }

        TextField{
            id:textfield;
            width:parent.width;
            placeholderText : qsTr("Search Game Name");
            inputMethodHints: Qt.ImhNoPredictiveText;
            onTextChanged: {
                searchRomindex(text);
            }
            ToolIcon{
                id:clear;
                anchors.right:parent.right;
                anchors.verticalCenter: parent.verticalCenter;
                iconId:"toolbar-close";
                onClicked: {
                    textfield.text="";
                }
            }
        }
        }
    //}

	ListView{
		id:lst;
		anchors.fill:parent;
        anchors.topMargin:head.height + tools.height;
		delegate:sign;
		focus: true;
		clip:true;
        spacing:2;
        onModelChanged: {
            textfield.text="";
        }

		/*
		section.criteria:ViewSection.FirstCharacter;
		section.property:"name";
		section.delegate:SectionDelegate{text:section}
		*/
	}

	ScrollDecorator{
		flickableItem:lst;
	}

	/*
	FastScroll {
		listView:lst;
	}
	*/
    function jump(index)
    {
        var i=parseInt(index);
        lst.currentIndex=i;
        lst.positionViewAtIndex(i,ListView.Beginning);
    }

	Component{
		id:sign;
		Rectangle{
            height:60;
			width:root.width;
			color:ListView.isCurrentItem?"lightsteelblue":"white";
			Column{
				anchors.fill:parent;
				Text{
					id:autoText;
					width:parent.width;
                    height:35;
					color:modelData.exists ? "red" : "black";
                    font.pointSize:18;
					elide:Text.ElideMiddle;
					text:modelData.name;
				}
				Text{
					id:autoText2;
					width:parent.width;
                    height:25;
                    font.pointSize:16;
					elide:Text.ElideMiddle;
					color:modelData.exists ? "red" : "black";
					text:modelData.year + "  " +  modelData.com;
				}
			}
			MouseArea{
				anchors.fill:parent;
				onClicked:{
					lst.currentIndex=index;
				}
				onDoubleClicked:{
					if(modelData.exists){
						openFbaFile(modelData.path);
					}
				}
			}
		}
	}
}
